<?php // Include only
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.1.0 - Last modified 11/21/2004
*/


// Microtime
function get_microtime() {
	$mtime = microtime();
	$mtime = explode(' ', $mtime);
	return doubleval($mtime[1]) + doubleval($mtime[0]);
}


// Flag check function
// Code contributed by Marcello (http://www.cellosoft.com)
function check_flag($c) {
	global $usrflags;
	return is_integer(strpos($usrflags, $c));
}
// <RanmaGuy> ill give you credit too :P in the file
// <marcello> hehe "thanks to marcello, I might actually have some miniscule speck of a clue on what I'm doing"


// Auto-slashes test
if (!get_magic_quotes_gpc()) {
	function slashit($in) {
		return addslashes($in);
	}
} else {
	set_magic_quotes_runtime(0);

	function slashit($in) {
		return $in;
	}
}


// Check for chars that break database
function badChars($text) {
	// Code from PHP.net

	$illegal = array('\'', '"', '$', '#', '&', '+', '=', '*', '/', '\\', ':', ';');
	$garb = array();

	foreach ($illegal as $k) {
		while (($j = strpos ($text, $k)) !== false) {
			$garb[] = $text{$j};
			$text = substr($text, 0, $j).substr($text, $j + 1);
		}
	}
	$garb = array_unique($garb);

	return $garb;
}


// Prepare path input (UNIX/URI only)
function strip_path($in) {
	// Strip trailing slash(es)
	$in = preg_replace('/\/+$/', '', $in);

	// Strip root, but not backtick
	$in = preg_replace('/^(\.\/)+/', '', $in);

	return $in;
}


// Checks for empty file
function check_file($in) {
	if (file_exists($in) && filesize($in) > 0) {
		return 1;
	} else {
		return 0;
	}
}


function get_filetype($data) {
	// Get types in approx. order of popularity

	$type = '';
	if (substr($data, 0, 8) == "\x89PNG\x0D\x0A\x1A\x0A") {
		$type = 'png';
	} elseif (substr($data, 0, 2) == "\xFF\xD8") {
		// JFIF only.  EXIF is not allowed.
		$type = 'jpg';
	} elseif (substr($data, 0, 3) == 'GIF') {
		$type = 'gif';
	} elseif (substr($buffer, 0, 2) == 'BM') {
		$type = 'bmp';
	} elseif (substr($data, 0, 23) == "\x00\x00\x00\x0CjP\x20\x20\x0D\x0A\x87\x0A\x00\x00\x00\x14ftypjp2") {
		$type = 'jp2';
	} elseif (substr($buffer, 0, 4) == '8BPS') {
		$type = 'psd';
	} elseif (substr($data, 0, 2) == 'PK') {
		$type = 'zip';
	}

	return $type;
}


// Forces file to be writable
// Returns FALSE bad input or missing file, 0 failure, 1 success
// INPUT: $filename, int CHMOD
function check_write($in, $mod = 755) {
	if ($mod == 0 || empty($in)) {
		// Bad input
		return FALSE;
	}
	$mod = sprintf("%04d", $mod);

	if (!file_exists($in)) {
		return FALSE;
	}

	if (!is_writable ($in)) {
		if (! @chmod($in, $mod)) {
			return 0;
		}
	}
	return 1;
}


// Web printing functions
function sql_check($result, $extra = '') {
	if (!$result) {
		echo mysql_error();
		if (!empty ($extra)) {
			echo ' ['.$extra.']';
		}
		echo "<br />\n";
		return 0;
	}
	return 1;
}
function web_line($line) {
	echo $line."<br />\n";
}


// Version number processing
// Returns keyed array of "usable" numbers
// INPUT: 'modname-x.y.z', 'x.y.z', 'modname-x.y', 'x.y' patterns
/* OUTPUT:
	'mod'=>'modname'
	'ver'=>"%03d%03d%03d" (5.12.14 = 005012014),
	'major'=>major num
	'minor'=>minor num
	'rev'=>revision num
*/
function version_split($input) {
	if ($input == 'Wac1.0') {
		// 'Wac1.0' fix
		return array ('mod'=>'wac', 'ver'=>001000000, 'major'=>1, 'minor'=>0, 'rev'=>0 );
	}

	// Note reverse search, so dashes can be in mod name
	$split = strrpos ($input, '-');

	if ($split) {
		// If there's a dash, get the mod name
		$ver_name = substr ($input, 0, $split);
		$ver_num  = substr ($input, $split + 1);
		$small = explode ('.', $ver_num);
	} else {
		$small = explode ('.', $input);
	}

	if (count($small) > 1) {
		// Major & minor required, revision optional
		if (!defined($small[2])) {
			$small[2] = 0;
		}
		$ver_num = ($small[0] * 1000000) + ($small[1] * 1000) + ($small[2] + 0);

		return array ('mod'=>$ver_name, 'ver'=>$ver_num, 'major'=>$small[0], 'minor'=>$small[1], 'rev'=>$small[2] );
	} else {
		// Not a valid number!
		return 0;
	}
}


function make_list(&$array, $sep, $delimiter = '') {
	$list = '';
	$items = count($array);

	if ($items == 1) {
		return $delimiter.$array[0].$delimiter;
	} elseif ($items > 0) {
		for ($i = 0; $i < ($items - 1); $i++) {
			$list .= $delimiter.$array[$i].$delimiter.$sep;
		}
		$list .= $delimiter.$array[$i].$delimiter;

		return $list;
	}

	return;
}
?>