<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.1.0 - Last modified 11/22/2004
*/


// Config
$CFG_update['debug']   = 0; // Prevents deletion of work files
$CFG_update['status']  = 0; // Init - error status returned by functions
$CFG_update['version'] = 'wac-1.1.0'; // Update to this version


// Init
include('common.php');
print_header();


// Import old config files
{
	$imports = array('config.php', 'dbconn.php');
	$import_fail = 0;
	$err_write = array();
	$err_include = array();
	foreach ($imports as $file) {
		if (file_exists ($file) && (! is_writable($file)) ) {
			$import_fail = 1;
			$err_write[] = $file; // push_array() shortcut
		}
		if (! @include($file)) {
			$import_fail = 1;
			$err_include[] = $file;
		}
	}
	if ($import_fail > 0) {
echo <<<EOF

<hr />

<p>
	<strong>
		Warning:  update failed due to the following errors:<br />
		<p>

EOF;

		// Not writable
		if (count($err_write) > 0) {
			echo "			Files not writable:  ";
			web_line( make_list($err_write, ', ', '"'));
		}

		// Cannot include
		if (count($err_include) > 0) {
			echo "			Files cannot be included:  ";
			web_line( make_list($err_include, ', ', '"'));
		}

echo <<<EOF
		</p>
	</strong>
	Update cannot continue.<br />
	<br />
	Make sure your old board is working properly before running this updater.
</p>
EOF;

		print_footer();
		exit;
	}
}


/* Get the current version numbers
	$old_versions = Array, for detecting bad/incomplete update
	$from_version_split = Array, seperated numbers for existing board
	$to_version_split   = Array, seperated numbers for new version
*/
$old_versions = array('cfg' => '', 'db' => '');
$from_version_split = array();
$to_version_split = array();
{
	// Poteto 4.x
	if (empty ($jpgcompression) && empty ($CFG_version)) {
		// (Assumed pre-5.0 release)
		$old_versions['cfg'] = 'op-4.0.0';
	}
	// Poteto 5.x
	if (isset ($jpgcompression) && empty ($CFG_version)) {
		$old_versions['cfg'] = 'op-5.0.0';
	}
	// Wac1.0
	if (isset ($requireart) && empty ($CFG_version)) {
		$old_versions['cfg'] = 'wac-1.0.0';
	}
	// wac-1.1.0 +
	if (isset ($CFG_version)) {
		$old_versions['cfg'] = $CFG_version;

		$result = mysql_query('SELECT miscstring FROM '.$OekakiPoteto_Prefix."oekakimisc WHERE miscname='dbversion'");
		if ($result) {
			$old_versions['db'] = mysql_result($result, 0);
		}
	}

	if (isset ($_POST['from_version'])) {
		$from_version_split = version_split($_POST['from_version']);
		$to_version_split = version_split($_POST['to_version']);
	}
}


// Print update options
if (!isset ($_POST['stage'])) {
	print_update_type($old_versions['cfg']);
}


// Collect update options; print control panel options
if ($_POST['stage'] == '1') {
	print_control_panel();
}


// Collect control panel options; perform the update
if ($_POST['stage'] == '2') {

	echo "<p>\n";

	if ($_POST['from_version'] == 'op-4.0.0' && $_POST['to_version'] == 'op-5.0.0') {
		if (op400_to_op500()) {
			print_OK();
		} elseif ($CFG_update['status'] > 0) {
			print_verify();
		} else {
			print_bad();
		}
	}
	elseif ($_POST['from_version'] == 'op-4.0.0' && $_POST['to_version'] == 'wac-1.1.0')
	{
		if (op400_to_op500()) {
			if (op500_to_wac100()) {
				if (op500_to_wac110(false)) {
					print_OK();
				} elseif ($CFG_update['status'] > 0) {
					web_line('');
					web_line('Update to OeakakiPoteto v5.1.0a successful, but update to Wacintaki failed.');
					print_verify();
				} else {
					print_bad();
				}
			} elseif ($CFG_update['status'] > 0) {
				web_line('');
				web_line('Update to OeakakiPoteto v5.1.0a successful, but update to Wacintaki failed.');
				print_verify();
			} else {
				print_bad();
			}
		} elseif ($CFG_update['status'] > 0) {
			print_verify();
		} else {
			print_bad();
		}
	}
	elseif ($_POST['from_version'] == 'op-5.0.0' && $_POST['to_version'] == 'wac-1.1.0')
	{
		if (OP500_to_wac100()) {
			if (wac100_to_wac110(false)) {
				print_OK();
			} elseif ($CFG_update['status'] > 0) {
				web_line('');
				web_line('Update to OeakakiPoteto v5.1.0a successful, but update to Wacintaki failed.');
				print_verify();
			} else {
				print_bad();
			}
		} else {
			print_bad();
		}
	}
	elseif ($_POST['from_version'] == 'wac-1.0.0' && $_POST['to_version'] == 'wac-1.1.0')
	{
		if (wac100_to_Wac110(false)) {
			print_OK();
		} elseif ($CFG_update['status'] > 0) {
			print_verify();
		} else {
			print_bad();
		}
	}
	elseif ($_POST['from_version'] == 'wac-1.1.0' && $_POST['to_version'] == 'wac-1.1.0')
	{
		if (wac100_to_Wac110(true)) {
			print_OK();
		} elseif ($CFG_update['status'] > 0) {
			print_verify();
		} else {
			print_bad();
		}
	}
	/* FUTURE */
	else
	{
echo <<<EOF
	<strong>Unsupported update type "From {$_POST['from_version']} to {$_POST['to_version']}" using updater version "{$CFG_update['version']}"!</strong><br />
	Board config version:  "{$old_versions['cfg']}",  database version:  "{$old_versions['db']}"<br />
	<br />
	Update cannot continue.<br />
	<br />
	If problems persist, try contacting me or visiting a Wacintaki support board and report the version information above.  A list of contacts is in the readme file that came with this updater.<br />
EOF;
	}

	echo "</p>\n";
}


print_footer();


// Finis
exit;



// ==================================================================
// General Functions
//
function print_header() {
	header('Content-type: text/html');
echo <<<EOF
<html>
<head>
	<title>OekakiPoteto Update</title>

	<style type="text/css" title="default">
		<!--
		h1 {
			font-family: "Helvetica", "Verdanna", sans-serif;
		}
		p {
			margin-left: 2em;
		}
		-->
	</style>
</head>

<body>


<h1>Wacintaki Poteto Update</h1>

<hr />

EOF;
}


function print_footer() {
	echo "\n\n</body>\n</html>";
}


function print_OK() {
	global $CFG_update;

echo <<<EOF
	<p>
		If you have multiple boards, make sure each board is at the current version.<br />
		<br />
		Click the button below to finalize the update.  This will delete the updater files and prevent security problems.<br />
	</p>

	<form action="index.php" method="post">

EOF;
	if ($CFG_update['debug'] == 0) {
		echo'		<input name="action" type="hidden" value="secure" />';
	}
echo <<<EOF
		<input name="submit" type="submit" value="Secure updater and go to the BBS" />
	</form>

EOF;
}


function print_bad() {
	global $CFG_update;

echo <<<EOF
	<p>
		Check your server permissions, the <em>config.php</em> and <em>dbconn.php</em> files, and try again.
	</p>
EOF;
}


function print_verify() {
	global $CFG_update;

echo <<<EOF
	<p>
		Errors occured during the update!  Please check the causes of the errors and run the updater again to ensure everything is set properly.  The updater can be run multiple times if required.
	</p>
EOF;
}


function print_update_type($detected_version) {
	// OekakiPoteto update
	if (substr($detected_version, 0, 2) == 'op') {
echo <<<EOF
<p>
	<strong>NOTICE:</strong>  If updating to Wacintaki, make sure you've deleted your old OekakiPoteto v5.x template and language files before running this updater.  Your old OekakiPoteto templates and language files WILL NOT WORK with Wacintaki Poteto.  See the readme file for more information.<br />
	<br />
	If updating from OekakiPoteto v4.x to v5.x, simply run this updater.
</p>

<hr />


EOF;
	}


	// v4.x update
	if ($detected_version == 'op-4.0.0') {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>OekakiPoteto v4.x suspected.  If this is correct, please select an update:</h4>
	<p>
		<input name="from_version" type="hidden" value="op-4.0.0" />
		<input name="to_version" type="radio" value="wac-1.1.0" checked />From v4.x to Wacintaki v1.1.0<br />
		<input name="to_version" type="radio" value="op-5.0.0" />From v4.x to v5.1.0a<br />
	</p>

	<p>
		If you are <strong>NOT</strong> using OekakiPoteto v4.x, please update to at least v4.x before running the Wacintaki updater or your BBS may be damaged!
	</p>

	<h4>Click Next to continue...</h4>
	<p>
		<input name="stage" type="hidden" value="1" />
		<input name="submit" type="submit" value="Next" />
	</p>
</form>

EOF;
	return 1;
	}


	// v5.x update
	if ($detected_version == 'op-5.0.0') {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>OekakiPoteto v5.x detected.</h4>
	<p>
		<input name="from_version" type="hidden" value="op-5.0.0" />
		<input name="to_version" type="hidden" value="wac-1.1.0" />
		Update will be to Wacintaki v1.1.0<br />
	</p>

EOF;
echo <<<EOF
	<h4>Click Next to continue...</h4>
	<p>
		<input name="stage" type="hidden" value="1" />
		<input name="submit" type="submit" value="Next" />
	</p>
</form>

EOF;
	return 1;
	}


	// Wacintaki update
	if (substr($detected_version, 0, 3) == 'wac') {
		// Make sure current BBS is not more recent than updater
		$detected_version_split = version_split($detected_version);
		if ($detected_version_split['ver'] < 1001001) {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>Wacintaki version "$detected_version" detected.</h4>
	<p>
		Update will be to Wacintaki v1.1.0<br />
	</p>

	<h4>Click Next to continue...</h4>
	<p>
		<input name="from_version" type="hidden" value="$detected_version" />
		<input name="to_version" type="hidden" value="wac-1.1.0" />

		<input name="stage" type="hidden" value="1" />
		<input name="submit" type="submit" value="Next" />
	</p>
</form>

EOF;
			return 1;
		} else {
echo <<<EOF
	<h4>Wacintaki version "$detected_version" detected.</h4>
	<p>
		This updater only supports Wacintaki versions less than or equal to v1.1.0.<br />
		<br />
		Update cannot continue.
	</p>

EOF;
			return 0;
		}
	}
}


function print_control_panel() {
	// OekakiPoteto 4.x to 5.1.0a
	if ($_POST['from_version'] == 'op-4.0.0' && $_POST['to_version'] == 'op-5.0.0') {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>No more information required.  Update to OekakiPoteto v5.1.0a...</h4>
	<p>
		<input name="from_version" type="hidden" value="op-4.0.0" />
		<input name="to_version" type="hidden" value="op-5.0.0" />

		<input name="stage" type="hidden" value="2" />
		<input name="submit" type="submit" value="Update" />
	</p>
</form>

EOF;
	} elseif ($_POST['from_version'] == 'op-4.0.0' || $_POST['from_version'] == 'op-5.0.0') {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>Control Panel:</h4>
	<p>
		Additional information is required for the update.<br />
		<br />
		Note: all options will be set to their default values.  You should verify everything in the Contol Panel after the update has completed.
	</p>

	<h4>Select a new default template.</h4>
	<p>
		<select name="updatetemplate">

EOF;

		if ($handle = opendir('templates')) {
			/* This is the correct way to loop over the directory. */
			while (false !== ($file = readdir($handle))) {
				if(substr($file,-4) == '.php'){
					if ($file == 'Banana.php') {
?>
			<option value="<?=substr($file,0,-4)?>" selected><?=substr($file,0,-4);?></option>
<?php
					} else {
?>
			<option value="<?=substr($file,0,-4)?>"><?=substr($file,0,-4);?></option>
<?php
					}
				}
			}
			closedir($handle);
		}

echo <<<EOF
		</select>
	</p>

	<h4>Enter your name as the BBS Author.</h4>
	<p>
		<input name="BBSauthor" type="text" value="" />
	</p>

	<h4>Is this strictly an adult-rated BBS?</h4>
	<p>
		<select name="BBSadult">
			<option value="yes">Yes</option>
			<option value="no" selected>No</option>
		</select>
	</p>

	<h4>Begin the update...</h4>
	<p>
		<input name="from_version" type="hidden" value="{$_POST['from_version']}" />
		<input name="to_version" type="hidden" value="{$_POST['to_version']}" />

		<input name="stage" type="hidden" value="2" />
		<input name="submit" type="submit" value="Update" />
	</p>
</form>
EOF;
	} else {
echo <<<EOF
<form name="form1" action="update.php" method="post">
	<h4>All new features will be set to their defaults.  View the Control Panel after the update to configure the new options.</h4>
	<p>
		<input name="from_version" type="hidden" value="{$_POST['from_version']}" />
		<input name="to_version" type="hidden" value="{$_POST['to_version']}" />

		<input name="stage" type="hidden" value="2" />
		<input name="submit" type="submit" value="Update" />
	</p>
</form>

EOF;
	}
}


// ==================================================================
// Update Functions
//
function OP400_to_OP500() {
	global $CFG_update;

	// Poteto v4.x to Poteto v5.1.0a
	$newversion = '5.1.0a';

	web_line('Update from v4.x to v5.1.0a...');

	/* We need to do the following:
		1) Add new values to config file:
			(UNKNOWN)

		2) Remove values from config file:
			(UNKNOWN)

		3) Add values to database:
			TABLE: oekakimailbox
			TABLE: oekakimisc
			TABLE: oekakichatmod
			TABLE: oekakichatmodusers

		4) Remove files if they exist:
			count
			install.php
	*/


	// Include config files
	if ( (! @include_once('dbconn.php')) && (! @include_once('config.php')) ) {
		web_line('STOP:  Cannot open "dbconn.php" and "config.php" files!');

		// Nothing done yet, so we can bail safely
		return 0;
	}


	// Upgrade count
	$fp2 = @fopen('count', 'r');
	if ($fp2) {
		$resno = fread ($fp2, filesize ('count'));
		fclose($fp2);
		trim($resno);
	} else {
		web_line('STOP:  Cannot get picture count from "count" file!');

		// Nothing done yet, so we can bail safely
		return 0;
	}

	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakichat RENAME ".$OekakiPoteto_MemberPrefix."oekakichat");
	sql_check($result);
	@$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakionline RENAME ".$OekakiPoteto_MemberPrefix."oekakionline");
	sql_check($result);
	@$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakikill RENAME ".$OekakiPoteto_MemberPrefix."oekakikill");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline ADD onlineboard TEXT NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE commcount commcount INT(11) DEFAULT '0' NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE piccount piccount INT(11) DEFAULT '0' NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline CHANGE OID OID BIGINT(255) NOT NULL AUTO_INCREMENT");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline CHANGE locale locale VARCHAR(30) DEFAULT NULL ");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta CHANGE PIC_ID PIC_ID int(11) DEFAULT '0' NOT NULL ");
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta CHANGE edittime edittime int(20) unsigned default NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta ADD postlock tinyint(4) NOT NULL default '0' ");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD age text");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta ADD animation tinyint(2) default '0'"); 
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD gender text");
	sql_check($result);
	$result = mysql_query("UPDATE ".$OekakiPoteto_Prefix."oekakidta SET postlock='1'");
	sql_check($result);
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakimailbox (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL,  body longtext NOT NULL,  mstatus smallint(10) NOT NULL default '0', senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever))"); 
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD language TEXT NOT NULL ");
	sql_check($result);
	$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='english'");
	sql_check($result);
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_Prefix."oekakimisc (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) NOT NULL,  PRIMARY KEY  (MiscID),  KEY miscname (miscname))");
	sql_check($result);


	$result = mysql_query("INSERT INTO ".$OekakiPoteto_Prefix."oekakimisc VALUES (1,'piccount','$resno')");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD picview TINYINT(11) DEFAULT '0' NOT NULL");
	sql_check($result);


	// Update chat
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmod (usrname varchar(255) NOT NULL default '',  command varchar(32) NOT NULL default 'MESSAGE',  comment tinytext NOT NULL,  posttime timestamp(14) NOT NULL,  hostname text NOT NULL,  email varchar(255) default NULL,  url text,  IP text NOT NULL,  postname varchar(50) NOT NULL default '',  PRIMARY KEY (posttime)) TYPE=MyISAM;");
	sql_check($result);

	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmodusers (usrname varchar(255) NOT NULL, lastmessage timestamp(14) NOT NULL, afk ENUM('no','yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM;");
	sql_check($result);

	mysql_close($dbconn);


	// Upgrade config
	// chmod('config.php', 0666);
	// chmod('dbconn.php', 0666);
	$fp = @fopen('config.php', 'w');
	if ($fp) {
		fwrite($fp, "<?php\n\n \$saltenc=\"".$saltenc."\"; \n \$OPpics=\"".$OPpics."\"; \n \$killuser=\"".$killuser."\"; \n \$template=\"".$template."\"; \n \$BBStitle=\"".$BBStitle."\"; \n \$eaddr=\"".$eaddr."\"; \n \$okurl=\"".$okurl."\"; \n \$apostrophes=\"".$apostrophes."\"; \n \$pstore=\"".$pstore."\"; \n \$ppage=\"".$ppage."\"; \n \$approval=\"".$approval."\"; \n \$drawaccess=\"".$drawaccess."\"; \n \$animationaccess=\"".$animationaccess."\"; \n \$xCanvas=\"".$xCanvas."\"; \n \$yCanvas=\"".$yCanvas."\"; \n \$xDefault=\"".$xDefault."\"; \n \$yDefault=\"".$yDefault."\"; \n \$chatMax=\"".$chatMax."\"; \n \$chatDisp=\"".$chatDisp."\"; \n \$language=\""."english"."\"; \n \$archivedir=\"".$archivedir."\"; \n \$guestpost=\"".$guestpost."\";\n \$anisize=\"".$anisize."\"; \n \$jpgcompression=\""."no"."\"; \n \$jpgcompressqual=\""."100"."\";\n\n?>");
		fclose($fp);
	} else {
		web_line('ERROR: Could not create new <em>config.php</em> file!');
		$CFG_update['status'] = 1;
	}


	// Remove install.php if it exists
	@unlink('count');
	if ($CFG_update['debug'] == 0) @unlink('install.php');


	//command to attempt to chmod the picture directory
	if (!check_write($OPpics, 777)) {
		web_line('ERROR: Picture directory "'.$OPpics.'" is not writable!  CHMOD the folder to 777 after the updater has finished.');
		$CFG_update['status'] = 1;
	}

	// Complete!
	if ($CFG_update['status'] == 0) {
		web_line('Update finished: OP v5.1.0a');
		web_line('');

		return 1;
	} else {
		return 0;
	}
}
// END OP400_to_OP500



function OP500_to_Wac100() {
	global $CFG_update;

	// Poteto v5.1.0a to Wacintaki Poteto v1.0.0
	$newversion = 'wac-1.0.0';

	web_line('Update from v5.1.0a to Wacintaki Poteto v1.0.0...');

	/* We need to do the following:
		1) Add new values to config file:
			$BBSauthor        = '';
			$OPPrefix         = '';
			$requireart       = 'no';
			$templatepath     = 'templates';
			$resourcepath     = 'resource';
			$perpage          = '25';
			$CFG_previewImg   = 'preview.png';
			$CFG_previewTitle = 'Canvas Preview';
			$xMin             = '50';
			$yMin             = '50';
			$aCanvas          = '250000'; (Unused for the moment)
			$useChat          = 'yes'; (Default for Poteto 5.1.0a)

		2) Remove values from config file:
			$apostrophes

		3) Update templates
			Ensure default is set, and change all user accounts to the default template.

		4) Verify that the chosen language file is available in Wacintaki Poteto.

		5) Remove files if they exist:
			announce.php
			arecover.php
			button.gif
			editnews.php
			flagchk.php
			install.php
			MgLine.zip
			news.php
			noteBBSa.php
			oekakiBBSa.php
			README.txt
			redirect.php
			tdesign.php
			tedit.php
			tedita.php
			template.php
			test.php
			tnew.php
			tnewa.php
			versionchk.php
	*/


	// Upgrade config
	include('config.php');
	include('dbconn.php');
	$OPpics       = strip_path($OPpics);
	$templatepath = strip_path($templatepath);
	$resourcepath = strip_path($resourcepath);

	if ($perpage == '') {
		// Only set defaults if not already updated.
		$BBSauthor = '';
		$BBSadult = 'no';
		$OPPrefix = '';
		$perpage = 25;
		$xMin = 50;
		$yMin = 50;
		$aCanvas = 250000;
		$requireart = 'no';
		$CFG_previewImg   = 'preview.png';
		$CFG_previewTitle = 'Canvas Preview';
		$templatepath = 'templates';
		$resourcepath = 'resource';
		$useChat = 'yes';
	}

	if ($_POST['updatetemplate'] != '') {
		$template  = $_POST['updatetemplate'];
		$BBSauthor = slashit ($_POST['BBSauthor']);
		$BBSadult  = $_POST['BBSadult'];
	}

	// Fix Wacintaki alpha version
	if (file_exists('resource') && $resourcepath == '') {
		$resourcepath = 'resource';
	}

	$main_configuration = <<<EOF
<?php // Include only

	\$BBStitle  = '$BBStitle';
	\$BBSauthor = '$BBSauthor';
	\$BBSadult  = '$BBSadult';
	\$eaddr     = '$eaddr';
	\$okurl     = '$okurl';

	\$saltenc    = '$saltenc';
	\$OPpics     = '$OPpics';
	\$archivedir = '$archivedir';
	\$OPPrefix   = '$OPPrefix';

	\$killuser   = '$killuser';
	\$approval   = '$approval';
	\$requireart = '$requireart';
	\$guestpost  = '$guestpost';
	\$drawaccess = '$drawaccess';
	\$animationaccess = '$animationaccess';

	\$language     = '$language';
	\$template     = '$template';
	\$templatepath = '$templatepath';
	\$resourcepath = '$resourcepath';

	\$pstore  = '$pstore';
	\$ppage   = '$ppage';
	\$perpage = '$perpage';

	\$CFG_previewImg   = '$CFG_previewImg';
	\$CFG_previewTitle = '$CFG_previewTitle';
	\$xDefault = '$xDefault';
	\$yDefault = '$yDefault';
	\$xCanvas  = '$xCanvas';
	\$yCanvas  = '$yCanvas';
	\$xMin     = '$xMin';
	\$yMin     = '$yMin';
	\$aCanvas  = '$aCanvas';
	\$anisize  = '$anisize';

	\$useChat  = '$useChat';
	\$chatMax  = '$chatMax';
	\$chatDisp = '$chatDisp';

	\$jpgcompression  = '$jpgcompression';
	\$jpgcompressqual = '$jpgcompressqual';

?>
EOF;
//<?


	// Write config file
	$fp = @fopen ('config.php', 'w');
	if ($fp) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
	} else {
		web_line('STOP:  Could not open config file for writing.  Check your server permissions');

		// Nothing done yet, so we can bail safely
		return 0;
	}


	// Update templates/languages
	{
		$newtemplate = slashit($_POST['updatetemplate']);
		if ($newtemplate == '') {
			$newtemplate = 'Default';
		}

		// Template
		$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE templatesel templatesel VARCHAR(255) DEFAULT '".$newtemplate."'");
		sql_check($result);

		$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET templatesel='".$newtemplate."'");
		sql_check($result);


		// Language
		if (file_exists ('language/'.$language.'.php')) {
			$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='".$language."'");
		} else {
			$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='english'");
		}
		sql_check($result);


		mysql_close($dbconn);
	}


	// Verify CHMOD
	if (!check_write($OPpics, 755)) {
		web_line('ERROR: Picture directory "'.$OPpics.'" is not writable!  CHMOD the folder to 755 or 777 after the updater has finished.');
	}

	if (!check_write('templates', 755)) {
		web_line('ERROR: Templates directory is not writable!  CHMOD the folder to 755 or 777 after the updater has finished.');
	}


	// Remove files if they exist
	{
		@unlink('announce.php');
		@unlink('arecover.php');
		@unlink('button.gif');
		@unlink('editnews.php');
		@unlink('flagchk.php');
		if ($CFG_update['debug'] == 0) @unlink('install.php');
		@unlink('MgLine.zip');
		@unlink('news.php');
		@unlink('noteBBSa.php');
		@unlink('oekakiBBSa.php');
		@unlink('README.txt');
		@unlink('redirect.php');
		@unlink('tdesign.php');
		@unlink('tedit.php');
		@unlink('tedita.php');
		@unlink('template.php');
		@unlink('test.php');
		@unlink('tnew.php');
		@unlink('tnewa.php');
		@unlink('versionchk.php');
	}


	// Complete!
	if ($CFG_update['status'] == 0) {
		web_line('Update finished: Wacintaki Poteto v1.0.0');
		web_line('');

		return 1;
	} else {
		return 0;
	}
}
// END OP500_to_Wac100


function Wac100_to_Wac110($force) {
	global $CFG_update;

	// Wacintaki Poteto 1.0.x to Wacintaki Poteto 1.1.0
	web_line('Update from Wacintaki Poteto v1.0.0 to v1.1.0...');

	/* We need to do the following:
		1) Add new values to config file:
			$CFG_version     = 'wac-1.1.0';
			$killreg         = '-1'; //WIP
			$guestdraw       = 'no'; //WIP
			$guestadult      = 'yes';
			$picLimit        = '2';  //WIP
			$picLimitTime    = '24'; //WIP
			$CFG_pornImg     = 'pr0n.png';
			$useThumb        = '2';
			$forceThumb      = 'no';
			$thumbBytes      = '100000';
			$thumbT          = '120';
			$thumbR          = '250';
			$thumbJPG        = '75'; //WIP
			$jpgcompression  = 'no'; //WIP
			$jpgcompressqual = '85'; //WIP
			$useMailbox      = 'no';
			$useSuggest      = 'no'; //WIP
			$suggestMax      = '50'; //WIP
			$suggestApprove  = 'no'; //WIP

		2) Add new values to database (finally):
			oekaki: thumbview
			oekaki: screensize
			oekakidta: threadlock
			oekakidta: px
			oekakidta: py
			oekakidta: ptype
			oekakidta: ttype
			oekakidta: rtype
			oekakidta: usethumb
			oekakimisc: miscstring

		3) Remove values from config file:
			(NONE)

		6) Remove files if they exist:
			compress.php
			install.php
	*/

	// Update DB
	include('config.php');
	include('dbconn.php');
	{
		// Ability to lock threads.
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD threadlock TINYINT NOT NULL DEFAULT 0');
		sql_check($result);

		// Picture sizes
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD px MEDIUMINT DEFAULT 0');
		sql_check($result);
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD py MEDIUMINT DEFAULT 0');
		sql_check($result);

		// Yes, VARCHAR for datatype (file extension) is better than INT as it allows for file uploads, not just pictures.  It also makes things easier for future mods.
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD ptype VARCHAR(4)');
		sql_check($result);
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD ttype VARCHAR(4)');
		sql_check($result);
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD rtype VARCHAR(4)');
		sql_check($result);

		// Records if thumbnail is available (built), unavailable, or should not be used (dimmentions or filesize too small, etc).
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_Prefix.'oekakidta ADD usethumb TINYINT NOT NULL DEFAULT 0');
		sql_check($result);

		// Thumbnail mode for each user
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_MemberPrefix.'oekaki ADD thumbview TINYINT NOT NULL DEFAULT 0');
		sql_check($result);

		// Screen size for each user
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_MemberPrefix.'oekaki ADD screensize MEDIUMINT NOT NULL DEFAULT 800');
		sql_check($result);

		// Version control
		$result = mysql_query('ALTER TABLE '.$OekakiPoteto_MemberPrefix.'oekakimisc ADD miscstring VARCHAR(14)');
		sql_check($result);

		// Done with DB update
		$result = mysql_query("INSERT INTO {$OekakiPoteto_Prefix}oekakimisc VALUES (2,'dbversion',0,'wac-1.1.0')");
		sql_check($result);
	}

	// Set DB values
	{
		// Sets view mode for each user to automatic (0)
		$result = mysql_query('UPDATE '.$OekakiPoteto_MemberPrefix.'oekaki SET picview=0');
		sql_check($result);
	}

	// Update config file
	{
		if (extension_loaded ('gd')) {
			$thumbnail_detect = 2;
		} else {
			$thumbnail_detect = 0;
		}

		$main_configuration = <<<EOF
<?php // Include only

	\$CFG_version = 'wac-1.1.0';

	\$BBStitle  = '$BBStitle';
	\$BBSauthor = '$BBSauthor';
	\$BBSadult  = '$BBSadult';
	\$eaddr     = '$eaddr';
	\$okurl     = '$okurl';

	\$saltenc    = '$saltenc';
	\$OPpics     = '$OPpics';
	\$archivedir = '$archivedir';
	\$OPPrefix   = '$OPPrefix';

	\$killuser   = '$killuser';
	\$killreg    = '-1'; //WIP
	\$approval   = '$approval';
	\$requireart = '$requireart';
	\$guestpost  = '$guestpost';
	\$guestdraw  = 'no'; //WIP
	\$guestadult = 'yes';
	\$drawaccess = '$drawaccess';
	\$animationaccess = '$animationaccess';

	\$language     = '$language';
	\$template     = '$template';
	\$templatepath = '$templatepath';
	\$resourcepath = '$resourcepath';

	\$pstore   = '$pstore';
	\$ppage    = '$ppage';
	\$perpage  = '$perpage';
	\$picLimit     = '2';  //WIP
	\$picLimitTime = '24'; //WIP

	\$CFG_pornImg      = 'pr0n.png';
	\$CFG_previewImg   = '$CFG_previewImg';
	\$CFG_previewTitle = '$CFG_previewTitle';
	\$xDefault = '$xDefault';
	\$yDefault = '$yDefault';
	\$xCanvas  = '$xCanvas';
	\$yCanvas  = '$yCanvas';
	\$xMin     = '$xMin';
	\$yMin     = '$yMin';
	\$aCanvas  = '$aCanvas';
	\$anisize  = '$anisize';

	\$useThumb   = '$thumbnail_detect';
	\$forceThumb = 'no';
	\$thumbBytes = '100000';
	\$thumbT     = '120';
	\$thumbR     = '250';
	\$thumbJPG   = '75'; //WIP
	\$jpgcompression   = 'no'; //WIP
	\$jpgcompressqual  = '85'; //WIP

	\$useMailbox = 'yes';

	\$useChat  = '$useChat';
	\$chatMax  = '$chatMax';
	\$chatDisp = '$chatDisp';

	\$useSuggest     = 'no'; //WIP
	\$suggestMax     = '50'; //WIP
	\$suggestApprove = 'no'; //WIP
?>
EOF;
//<?

		// Write the config file
		if ($fp = fopen ('config.php', 'w')) {
			fwrite ($fp, $main_configuration);
			fclose ($fp);
		} else {
			web_line('<strong>ERROR</strong>: Could not open config file "config.php" for writing.  Check your server permissions.');
			$CFG_update['status'] = 1;
		}
	}

	// Build ptypes
	{
		/*
		It's possible the source image can be a JPEG or PNG but there's no way to tell which is the primarty image unless we search the filesystem for both.  This is partly my fault thanks to my upload script which allows people to upload JPEGs if $jpgcompression is enabled (normally, Poteto can only use PNGs).

		If a PNG exists, we always use that, but if a JPEG exists exclusively, we use that instead.  Rather than bang the filesys, we'll read the directory and do lots of string searching to find out what's available.  There's probably a better way using stacks, but I'm stupid.  :)
		*/

		// Read the dir
		$handle = opendir($OPpics);
		$prefix_len = strlen ($OPPrefix) + 1;
		while ($file = readdir($handle)){
			if (substr ($file, -4) == '.png' || substr ($file, -4) == '.jpg') {
				$thumbtest = substr ($file, 0, $prefix_len);
				if ($thumbtest != $OPPrefix.'t' && $thumbtest != $OPPrefix.'r') {
					$files[] = $file;
				}
			}
		}
		closedir($handle);

		// Collect database entries and let's sort things out
		$result = mysql_query('SELECT ID_2, PIC_ID, px, py, ptype FROM '.$OekakiPoteto_Prefix.'oekakidta');
		$total_rows = mysql_num_rows($result);

		for ($i = 0; $i < $total_rows; $i++) {
			$row = mysql_fetch_array($result);
			$res_jpg = $OPPrefix.$row['PIC_ID'].'.jpg';
			$res_png = $OPPrefix.$row['PIC_ID'].'.png';

			// If ptype is occupied, we do nothing unless a force is needed.
			if (empty ($row['ptype']) || $force == true) {
				$found_png = false;
				$found_jpg = false;

				// Get the pic's datatype
				foreach ($files as $file) {
					if ($file == $res_png) {
						$found_png = true;
						break;
					}
				}
				if (!$found_png) {
					foreach ($files as $file) {
						if ($file == $res_jpg) {
							$found_jpg = true;
							break;
						}
					}
				}

				// Use PNG if avaiable, otherwise, use JPEG
				if ($found_png) {
					$row['ptype'] = 'png';
				} elseif ($found_jpg) {
					$row['ptype'] = 'jpg';
				}


				// Verify.  Check ptype first to avoid filesys slowdown
				$image = $OPpics.'/'.$OPPrefix.$row['PIC_ID'].'.'.$row['ptype'];
				if (!empty ($row['ptype']) && file_exists ($image)) {
					$sizes = GetImageSize($image);

					// OK, we've got all our info.  Insert it into DB
					if ($debug == 1) {
						web_line("PIC: {$row['PIC_ID']}, <strong>X: {$sizes[0]}, Y: {$sizes[1]}</strong>, TYPE: {$row['ptype']}");
					} else {
						$result2 = mysql_query('UPDATE '.$OekakiPoteto_Prefix."oekakidta SET px={$sizes[0]}, py={$sizes[1]}, ptype='{$row['ptype']}' WHERE PIC_ID='{$row['PIC_ID']}'");
						sql_check($result2);
					}
				} else {
					// D'OH!  Picture missing!
					web_line('<strong>NOTE:</strong> missing image "'.$OPPrefix.$row['PIC_ID'].'.xxx" for post '.$row['ID_2'].'!  Consider deleting the post rather than trying to FTP a picture into the pictures folder.');
				}
			}
		}
	}
	// End build ptypes


	// Remove files if they exist
	{
		@unlink('compress.php');
		if ($CFG_update['debug'] == 0) @unlink('install.php');
	}


	// Remove obsolete templates
	if ($handle = opendir('templates')) {
		/* This is the correct way to loop over the directory. */
		while (false !== ($file = readdir($handle))) {
			if(substr($file,-4) == '.css'){
				echo $file.' ';
				if ($file != 'Default.css' && $file != 'Install.css') {
					echo '<strong>'.$file.'</strong> ';
					@unlink ('templates/'.$file);
				}
			}
		}
		closedir($handle);
	}


	// Complete!
	if ($CFG_update['status'] == 0 || $force == true) {
		web_line('Update finished: Wacintaki Poteto v1.1.0');
		web_line('');

		return 1;
	} else {
		return 0;
	}
}
// END Wac100_to_Wac110


?>